## The random forest code using sklearn functions

import psycopg2
import pandas as pd
# https://www.mltut.com/svm-implementation-in-python-from-scratch/#what-is-support-vector-machine


import datetime
start_time = datetime.datetime.now()

# https://www.tutorialspoint.com/python_data_access/python_mysql_database_connection.htm
# https://naysan.ca/2020/05/31/postgresql-to-pandas/
#establishing the connection
conn = psycopg2.connect(
   database="mqp", user='postgres', password='password', host='127.0.0.1', port= '5432'
)
cursor = conn.cursor()
cursor.execute("select * from transfusion")
tuples = cursor.fetchall()
cursor.close()
column_names = ['X1','X2','X3','X4','Y']
df = pd.DataFrame(tuples, columns=column_names)
conn.close()

X = df.iloc[:, [0,1,2, 3]].values
y = df.iloc[:, 4].values



from sklearn.model_selection import train_test_split
X_train, X_test, y_train, y_test = train_test_split(X, y, train_size = 0.8, random_state = 1, shuffle=False)

from sklearn.preprocessing import StandardScaler
sc = StandardScaler()
X_train = sc.fit_transform(X_train)
X_test = sc.transform(X_test)

from sklearn.svm import SVC
classifier = SVC(C=0.01,kernel = 'linear', random_state = 1, max_iter=2000)
classifier.fit(X_train, y_train)

y_pred = classifier.predict(X_test)

from sklearn.metrics import accuracy_score
print("Accuracy rate: {}".format(accuracy_score(y_test, y_pred)))

end_time = datetime.datetime.now()

time_diff = (end_time - start_time)
execution_time = time_diff.total_seconds() * 1000

print("Time: ", execution_time, "ms")
